Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_unsigned.all;

entity Memory_Data_Out_Mux is 
	port( 	
			Addr_to_Mem		: in std_logic_vector(23 downto 0);
			Param_Data_In	: in std_logic_vector(15 downto 0);
			Buf_1_Data		: in std_logic_vector(15 downto 0);
			Buf_2_Data		: in std_logic_vector(15 downto 0);
			Buf_3_Data		: in std_logic_vector(15 downto 0);
			Buf_4_Data		: in std_logic_vector(15 downto 0);
			USB_Mode		: in std_logic_vector( 7 downto 0);

			Mem_Data_to_USB	: out std_logic_vector(15 downto 0)
			        
		);
	end Memory_Data_Out_Mux;
	
architecture main of Memory_Data_Out_Mux is	

signal ADDR 		: std_logic_vector(23 downto 0);
signal chan_mode	: std_logic;
signal chan_select	: std_logic_vector(4 downto 0);
             
begin

	ADDR 		<= Addr_to_Mem;
	chan_mode 	<= USB_Mode(6);
	chan_select <= USB_Mode(4 downto 0);	
    
	DATA_MUX: 
	process(ADDR, Param_Data_In, Buf_1_Data, Buf_2_Data, Buf_3_Data,
			Buf_4_Data, chan_mode, chan_select)
	begin
		if   (chan_mode = '1') then -- channel mode
			case chan_select is
				when "00000" 	=>	Mem_Data_to_USB <= Buf_1_Data;
				when "00001" 	=>	Mem_Data_to_USB <= Buf_2_Data;
				when "00010" 	=>	Mem_Data_to_USB <= Buf_3_Data;
				when "00011" 	=>	Mem_Data_to_USB <= Buf_4_Data;
				when others 	=>	Mem_Data_to_USB <= X"BAD1";
			end case;
		elsif (ADDR < X"20")  then	Mem_Data_to_USB <= Param_Data_In;
		else						Mem_Data_to_USB <= X"BAD2";
		end if;
	end process;
end;