Library IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

-- My Definitions --------------------------------------------------

--Version 4 breaks the EXTERNAL / MADC1 Switch logic out from the 
-- Accel_PL_Ena and Start / Stop logic.

entity Shift_Reg_Delay_32 is
	port(clk        		: in std_logic;
		 nreset     		: in std_logic;
		 Data_in	 			: in std_logic;
		 Delay_Cnt			: in std_logic_vector(4 downto 0);

 		 Data_Out			: out std_logic
		);
end Shift_Reg_Delay_32;
	
architecture main of Shift_Reg_Delay_32 is

signal q		: std_logic_vector(31 downto 1);

-- ## MAIN ##############################################################
begin 

SHIFT_REG: process(clk, nreset, Data_in, q)
begin
	if  (nreset = '0') then 	q <= (others => '0');
	elsif rising_edge(clk) then
		q(1) <= Data_In;
		q(2) <= q(1);
		q(3) <= q(2);
		q(4) <= q(3);
		q(5) <= q(4);
		q(6) <= q(5);
		q(7) <= q(6);
		q(8) <= q(7);
		q(9) <= q(8);
		q(10) <= q(9);
		q(11) <= q(10);
		q(12) <= q(11);
		q(13) <= q(12);
		q(14) <= q(13);
		q(15) <= q(14);
		q(16) <= q(15);
		q(17) <= q(16);
		q(18) <= q(17);
		q(19) <= q(18);
		q(20) <= q(19);
		q(21) <= q(20);
		q(22) <= q(21);
		q(23) <= q(22);
		q(24) <= q(23);
		q(25) <= q(24);
		q(26) <= q(25);
		q(27) <= q(26);
		q(28) <= q(27);
		q(29) <= q(28);
		q(30) <= q(29);
		q(31) <= q(30);		          
	end if;
end process;

MUX:process (Delay_Cnt, Data_in, q)
begin
	
	case Delay_Cnt is
		when "00000"   => Data_out <= Data_in;  
		when "00001"   => Data_out <= q(1);  
		when "00010"   => Data_out <= q(2) ;  
		when "00011"   => Data_out <= q(3) ;  
		when "00100"   => Data_out <= q(4) ;  
		when "00101"   => Data_out <= q(5) ;  
		when "00110"   => Data_out <= q(6) ;  
		when "00111"   => Data_out <= q(7) ;  
		when "01000"   => Data_out <= q(8) ;  
		when "01001"   => Data_out <= q(9) ;  
		when "01010"   => Data_out <= q(10);  
		when "01011"   => Data_out <= q(11);  
		when "01100"   => Data_out <= q(12);  
		when "01101"   => Data_out <= q(13);  
		when "01110"   => Data_out <= q(14);  
		when "01111"   => Data_out <= q(15);  
		when "10000"   => Data_out <= q(16);  
		when "10001"   => Data_out <= q(17);  
		when "10010"   => Data_out <= q(18);  
		when "10011"   => Data_out <= q(19);  
		when "10100"   => Data_out <= q(20);  
		when "10101"   => Data_out <= q(21);  
		when "10110"   => Data_out <= q(22);  
		when "10111"   => Data_out <= q(23);  
		when "11000"   => Data_out <= q(24);  
		when "11001"   => Data_out <= q(25);  
		when "11010"   => Data_out <= q(26);  
		when "11011"   => Data_out <= q(27);  
		when "11100"   => Data_out <= q(28);  
		when "11101"   => Data_out <= q(29);  
		when "11110"   => Data_out <= q(30);  
		when "11111"   => Data_out <= q(31);  
                                  
		when others =>	Data_out <= Data_in;
	end case; 
			
end process;

end main;